import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkCarousel, ThinkCarouselParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkCarousel(params: ThinkCarouselParam) {
  const res = await request.get<ApiResult<PageResult<ThinkCarousel>>>(
    THINK_API_URL + '/think/think-carousel/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkCarousel(params?: ThinkCarouselParam) {
  const res = await request.get<ApiResult<ThinkCarousel[]>>(
    THINK_API_URL + '/think/think-carousel',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkCarousel(data: ThinkCarousel) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-carousel',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkCarousel(data: ThinkCarousel) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-carousel',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkCarousel(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-carousel/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkCarousel(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-carousel/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkCarousel(id: number) {
  const res = await request.get<ApiResult<ThinkCarousel>>(
    THINK_API_URL + '/think/think-carousel/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
